Jqpress.Web/Areas/Admin/Controllers/OptionController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Web;
using System.Web.Mvc;
using Jqpress.Framework.Configuration;
using Jqpress.Framework.Utils;
using Jqpress.Framework.Web;
using Jqpress.Framework.Mvc;
using Jqpress.Core.Domain;
using Jqpress.Core.Services;
using Jqpress.Core.Configuration;
using Jqpress.Web.Areas.Admin.Models;
using FileInfo = Jqpress.Core.Domain.FileInfo;

namespace Jqpress.Web.Areas.Admin.Controllers
{
    public class OptionController : BaseAdminController
    {
        private string FileName;
        public string urlpath = PressRequest.GetQueryString("path");
        public string rootpath = "/upfiles";

        public ActionResult Site() 
        {
            var config = SiteConfig.GetSetting();
            return View(config);
        }

        /// <summary>
        /// 样式
        /// </summary>
        /// <returns></returns>
        public ActionResult Themes() 
        {
            ThemeService themeService = new ThemeService();
            var config = SiteConfig.GetSetting();

            var model = new ThemeListModel();
            model.ThemeList = themeService.GetThemeList();
            model.CurrentTheme = config.Theme;

            return View(model);
        }
        /// <summary>
        /// 主题编辑
        /// </summary>
        /// <param name="themename"></param>
        /// <returns></returns>
        public ActionResult ThemeEdit(string themename) 
        {


            var model = new ThemeModel();
            if (!string.IsNullOrEmpty(themename)) 
            {
                var path = "/themes/"+themename;
                if (!string.IsNullOrEmpty(urlpath)) 
                {
                    path = urlpath;
                }
                model = GetFilesList(path);
                if (!string.IsNullOrEmpty(urlpath))
                {
                    model.PathUrl = GetPathUrl();
                }

            }
            ViewBag.UrlPath = System.IO.Path.GetFileName(Request.Url.AbsolutePath);
            return View(model);
        }
        public ThemeModel GetFilesList(string path)
        {
            path = path.Replace("//", "/");
            var model = new ThemeModel();
            if (!Directory.Exists(Server.MapPath(path)))
                return model;

            var dic = new DirectoryInfo(Server.MapPath(path));
            foreach (var d in dic.GetFileSystemInfos())
            {
                if (d is DirectoryInfo)
                {
                    var fold = new FoldInfo
                    {
                        FoldName = d.Name,
                        FoldPath = path,
                        FileSystemInfosLength = ((DirectoryInfo)d).GetFileSystemInfos().Length,
                        UpdateTime = d.LastWriteTime
                    };
                    model.FoldList.Add(fold);
                }
                else
                {
                    var file = new FileInfo
                    {
                        FileName = d.Name,
                        FileLength = FileHelper.ConvertUnit(((System.IO.FileInfo)d).Length),
                        Extension = d.Extension,
                        FileUrl = path + "/" + d.Name,
                        FilePath = d.FullName,
                        UpdateTime = d.LastWriteTime
                    };
                    model.FileList.Add(file);
                }
            }
            return model;
        }

        /// <summary>
        /// 获取当前路径所有连接
        /// </summary>
        protected string GetPathUrl()
        {
            string pathLink = string.Empty;
            FileName = System.IO.Path.GetFileName(Request.Url.AbsolutePath);
            urlpath = urlpath.Replace("//", "");
            string path2 = urlpath.Substring(1, urlpath.Length - 1);

            string[] tempPath = path2.Split('/');

            string temp = "/";

            pathLink = ConfigHelper.SitePath.TrimEnd('/');

            for (int i = 0; i < tempPath.Length; i++)
            {

                temp += (i != 0 ? "/" : "") + tempPath[i];
                if (i == 0 && ConfigHelper.SitePath.Length > 1) //有虚拟目录
                {
                    continue;
                }
                pathLink += string.Format("/<a  href='/admin/option/{2}?themename={2}&path={0}'>{1}</a>", temp, tempPath[i], FileName,Request["themename"]);
            }
            return pathLink.Replace("//", "");
        }


        /// <summary>
        /// 更新配置
        /// </summary>
        /// <returns></returns>
        [HttpPost, ActionName("SaveConfig"), ValidateInput(false)]
        public ActionResult SaveConfig(SiteConfigInfo configInfo) 
        {
            var  config= SiteConfig.GetSetting();
            config.SiteName = configInfo.SiteName;
            config.MetaKeywords = configInfo.MetaKeywords;
            config.MetaDescription = configInfo.MetaDescription;
            config.FooterHtml = configInfo.FooterHtml;
            SiteConfig.UpdateSetting();
            SuccessNotification("保存成功");
            return RedirectToAction("site");
        }

        /// <summary>
        /// 保存主题
        /// </summary>
        /// <returns></returns>
        public ActionResult UseTheme()
        {
            var themename = PressRequest.GetQueryString("themename");
            var config = SiteConfig.GetSetting();
            config.Theme = themename;
            SiteConfig.UpdateSetting();
            SuccessNotification("设置成功");
            return RedirectToAction("themes");
        }

    }
}

Jqpress.Web/Areas/Admin/Views/Option/Site.cshtml
@using Jqpress.Framework.Mvc
@model Jqpress.Core.Domain.SiteConfigInfo
@{
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
    ViewBag.Title = "站点设置 - 管理中心 - Powered by Jqpress";
}

<!-- BEGIN PAGE HEADER-->
<div class="row">
<div class="col-md-12">
    <!-- BEGIN PAGE TITLE & BREADCRUMB-->
    <h3 class="page-title">
        站点设置
    </h3>
    <!-- END PAGE TITLE & BREADCRUMB-->
</div>
</div>
<!-- END PAGE HEADER-->
        
 @Html.JPartial("_Notifications")

 <div class="portlet-body">

 <form name="form1" method="post" action="@Url.Action("SaveConfig", "Option")" enctype="multipart/form-data" >

                     <ul  class="nav nav-tabs">
                        <li class="active"><a href="#tab_1_1" data-toggle="tab">基本设置</a></li>
                     <!--   <li class=""><a href="#tab_1_2" data-toggle="tab">邮箱</a></li>-->
                     <!--   <li class=""><a href="#tab_1_3" data-toggle="tab">首页幻灯片</a></li>-->
                        
                     </ul>
                     <div  class="tab-content">
                        <div class="tab-pane fade active in" id="tab_1_1">
                                <div class="form-group">
                                    <label for="SiteName" style="width:180px">网站名称：</label>
                                    <input type="text" id="SiteName" name="SiteName" value="@Model.SiteName" class="form-control"  style="width:60%" />
                                </div>
                                <div class="form-group">
                                    <label for="MetaKeywords"  style="width:180px">关键词：</label>
                                    <input type="text" id="MetaKeywords" name="MetaKeywords" value="@Model.MetaKeywords" class="form-control"  style="width:60%" />
                                </div>
                                <div class="form-group">
                                    <label for="MetaDescription"  style="width:180px">描述：</label>
                                    <input type="text" id="MetaDescription" name="MetaDescription" value="@Model.MetaDescription" class="form-control"  style="width:60%" />
                                </div>
                                <div class="form-group">
                                    <label for="FooterHtml"  style="width:180px">站点底部信息：</label>

                                    <textarea class="form-control" id="FooterHtml" name="FooterHtml"  rows="5"  style="width:60%">@Model.FooterHtml</textarea>                                </div>

                        </div>
                        <div class="tab-pane fade" id="tab_1_2">
                           <p>Food truck fixie locavore, accusamus mcsweeney's marfa nulla single-origin coffee squid. Exercitation +1 labore velit, blog sartorial PBR leggings next level wes anderson artisan four loko farm-to-table craft beer twee. Qui photo booth letterpress, commodo enim craft beer mlkshk aliquip jean shorts ullamco ad vinyl cillum PBR. Homo nostrud organic, assumenda labore aesthetic magna delectus mollit. Keytar helvetica VHS salvia yr, vero magna velit sapiente labore stumptown. Vegan fanny pack odio cillum wes anderson 8-bit, sustainable jean shorts beard ut DIY ethical culpa terry richardson biodiesel. Art party scenester stumptown, tumblr butcher vero sint qui sapiente accusamus tattooed echo park.</p>
                        </div>
                        <div class="tab-pane fade" id="tab_1_3">
                           <p>Etsy mixtape wayfarers, ethical wes anderson tofu before they sold out mcsweeney's organic lomo retro fanny pack lo-fi farm-to-table readymade. Messenger bag gentrify pitchfork tattooed craft beer, iphone skateboard locavore carles etsy salvia banksy hoodie helvetica. DIY synth PBR banksy irony. Leggings gentrify squid 8-bit cred pitchfork. Williamsburg banh mi whatever gluten-free, carles pitchfork biodiesel fixie etsy retro mlkshk vice blog. Scenester cred you probably haven't heard of them, vinyl craft beer blog stumptown. Pitchfork sustainable tofu synth chambray yr.</p>
                        </div>
                        <div class="tab-pane fade" id="tab_1_4">
                           <p>Trust fund seitan letterpress, keytar raw denim keffiyeh etsy art party before they sold out master cleanse gluten-free squid scenester freegan cosby sweater. Fanny pack portland seitan DIY, art party locavore wolf cliche high life echo park Austin. Cred vinyl keffiyeh DIY salvia PBR, banh mi before they sold out farm-to-table VHS viral locavore cosby sweater. Lomo wolf viral, mustache readymade thundercats keffiyeh craft beer marfa ethical. Wolf salvia freegan, sartorial keffiyeh echo park vegan.</p>
                        </div>
                     </div>

        <div class="form-group">
            <button type="submit" name="btnSave"   id="btnSave" class="btn btn-primary" >保存</button>
        </div>
 </form>
</div>


    <script src="/assets/scripts/app.js"></script>
   <script>
       jQuery(document).ready(function () {
           App.init();
       });
   </script>

Jqpress.Web/Areas/Admin/Views/Option/ThemeEdit.cshtml
@using System.IO
@using Jqpress.Framework.Mvc
@using Jqpress.Core.Configuration
@using Jqpress.Framework.Web;
@model Jqpress.Web.Areas.Admin.Models.ThemeModel
@{
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
    ViewBag.Title =  "模板编辑 - 管理中心 - Powered by Jqpress";
}


<!-- BEGIN PAGE HEADER-->
<div class="row">
<div class="col-md-12">
    <!-- BEGIN PAGE TITLE & BREADCRUMB-->
    <h3 class="page-title">
        模板编辑
    </h3>
    <!-- END PAGE TITLE & BREADCRUMB-->
</div>
<div>地址：@Html.Raw(Model.PathUrl)</div>
</div>
<!-- END PAGE HEADER-->
        
 <div class="portlet-body">

 <form class="search-form" role="form" method="get" action="@Url.Action("List", "Post")">
                     <table class="table table-striped table-bordered table-hover" >
                        <thead>
                           <tr>
                             <th>名称</th>
			                <th>修改时间</th>
			                <th>大小</th>
			                <th>操作</th>
                           </tr>
                        </thead>
                        <tbody>

                              @foreach (var item in Model.FoldList)
                              {
		                              <tr id="post@(item.FoldName)" class="odd gradeX">
			                            <td>
			                           <a href="@ViewBag.UrlPath?themename=@Request["themename"]&path=@item.FoldPath/@item.FoldName"><img src="/assets/img/foldmin.png" /> @item.FoldName</a>
			                            </td>
			                            <td>@item.UpdateTime</td>
			                            <td>@item.FileSystemInfosLength </td>
			                            <td>
			  	                            <span><a href="edit?id=@item.FoldName"> 编辑 </a></span>
				                            <span><a onclick="return confirm('确定删除，将会删除文件夹?');" href="delete?id=@item.FoldName"> 删除</a></span>
		                                </td>
		                              </tr>
                              }
                             @foreach (var item in Model.FileList)
                             {
		                              <tr id="post@(item.FileName)" class="odd gradeX">
			                            <td>
			                             <img src="/assets/img/txt.gif" style="width:14px; height:15px" /> @item.FileName
			                            </td>
			                            <td>@item.UpdateTime</td>
			                            <td>@item.FileLength </td>
			                            <td>
			  	                            <span><a href="edit?id=@item.FileName"> 编辑 </a></span>
				                            <span><a onclick="return confirm('确定删除?');" href="delete?id=@item.FileName"> 删除</a></span>
		                                </td>
		                              </tr>
                             }
                        </tbody>
                     </table>
                      </form>
  </div>

Jqpress.Web/Areas/Admin/Views/Option/Themes.cshtml
@using Jqpress.Framework.Mvc
@model Jqpress.Web.Areas.Admin.Models.ThemeListModel

@{
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
    ViewBag.Title = "主题设置 - 管理中心 - Powered by Jqpress";
}

<style>
    .themes{ padding: 1px;}
.themes h3 {
  margin-bottom: 0;
    margin-top: 0px;
  padding: 10px;
  border-radius: 4px;
}

.themes small {
  display:block; 
  font-size:12px;
}

.themes .theme-info {
  padding: 10px;
  overflow: hidden; 
  background: #f5f5f5;
}
</style>

<!-- BEGIN PAGE HEADER-->
<div class="row">
<div class="col-md-12">
    <!-- BEGIN PAGE TITLE & BREADCRUMB-->
    <h3 class="page-title">
        主题设置
    </h3>
    <!-- END PAGE TITLE & BREADCRUMB-->
</div>
</div>
<!-- END PAGE HEADER-->
        

 @Html.JPartial("_Notifications")

<div class="portlet-body">
         <div class="row thumbnails">

         @foreach(var theme in Model.ThemeList)
         {
             <div class="col-md-3">
                 <div class="themes"
                 @if (Model.CurrentTheme == theme.Name)
                 {
                     @:style="border: 1px solid #F7CB1B;"
                 }
                 >
                  <h3>@theme.Name</h3>
                  <img src="@theme.Thumbnail" alt="" class="img-responsive" />

                  <div class="theme-info">
                     <a href="@Url.Action("index", "home", new { area = "", theme = theme.Folder })" class="btn btn-default">预览</a>
                    <!--  <a href="@Url.Action("themeedit","option",new {themename=theme.Folder})" class="btn btn-default">编辑</a>-->
                      @if (Model.CurrentTheme == theme.Name)
                      {
                          <a href="#" class="btn btn-default disabled">启用</a>
                      }
                      else
                      {
                        <a href="@Url.Action("usetheme", "option", new { themename = theme.Folder })" class="btn btn-success">启用</a>                          
                      }
                      <!--  <button type="button" class="btn btn-default">删除</button>-->
                  </div>
               </div>
            </div>
         }
            
         </div>
                     
</div>


    <script src="/assets/scripts/app.js"></script>
   <script>
       jQuery(document).ready(function () {
           App.init();
       });
   </script>